
label variable texpf "Final good exports"
label variable DVAexpf "DVA in direct final goods"
label variable FVAexpf "Foreign VA in final goods"
label variable texpi "Intermediate goods exports"
label variable DVAINT1 "DVA in intermediate absorded by direct importer"
label variable DVAINT2 "DVA in intermediate absorded by direct importer - via third countries"
label variable INDDVAF "Indirect VA exports to third countries "
label variable RFLDVAF1 "Returned DVA in final goods imports -from direct importer"
label variable RELDVAF2 "Returned DVA in final goods imports -via third countries"
label variable REFLDVAI "Returned DVA in intermediate imports"
label variable DDf "Double counted DVA used to produce final goods exports"
label variable DDi "Double counted DVA used to produce intermedite exports"
label variable FVAexpi " FVA in intermediate exports"
label variable DFF "Double counted FVA used to produce final goods exports"
label variable DFI "Double counted FVA used to produce intermedite exports"
label variable VAEXPb "DVA exports - backward looking method"
label variable VAEXP "DVA exports - forward looking method"
label variable texp "Gross exports"
label variable DVADOMT "GDP absorbed in home- backward look method"
label variable DVADOMD "DVA in domestic final goods sales - absorbed in home directly"
label variable DVADOMRF "DVA in final goods imports"
label variable DVADOMRI "DVA in intermediate imports"
label variable VBSDFD "FVA in domestic final goods sales"
label variable DFD " Domestic final goods sales"
label variable domvab "GDP absorbed in home- forward look method"
label variable GDP "GDP by industry"
label variable U_w "Upstreamness"
label variable VA "Value added"
label variable II "Intermediate use"
label variable GO "Gross output"
label variable LAB "Labor input"
label variable VA_P "Value added deflator"
label variable GO_P "Gross output deflator"

encode countrycode, gen(country)

* variables in national currency
foreach variable in texpf texpi texp DVAexpf FVAexpf DVAINT1 DVAINT2 INDDVAF RFLDVAF1 RELDVAF2	REFLDVAI DDf DDi FVAexpi DFF DFI VAEXPb	VAEXP DVADOMT DVADOMD DVADOMRF DVADOMRI VBSDFD	DFD	domvab	GDP {
gen `variable'_n =  `variable' / erate
}

* variables in real terms
foreach variable in DVAexpf	FVAexpf	DVAINT1	DVAINT2	INDDVAF	RFLDVAF1	RELDVAF2	REFLDVAI	DDf	DDi	FVAexpi	DFF	DFI	VAEXPb	VAEXP	DVADOMT	DVADOMD	DVADOMRF	DVADOMRI	VBSDFD	DFD	domvab	GDP {
gen `variable'_r = 100* `variable' / VA_P 
}

* variables in real terms in national currency
foreach variable in DVAexpf	FVAexpf	DVAINT1	DVAINT2	INDDVAF	RFLDVAF1	RELDVAF2	REFLDVAI	DDf	DDi	FVAexpi	DFF	DFI	VAEXPb	VAEXP	DVADOMT	DVADOMD	DVADOMRF	DVADOMRI	VBSDFD	DFD	domvab	GDP  {
gen `variable'_r_n = 100* `variable' / (VA_P  * erate)
}

foreach variable in  texpf texpi texp {
gen `variable'_r = 100* `variable' / GO_P 
}

foreach variable in  texpf texpi texp {
gen `variable'_r_n = 100* `variable' / (GO_P  * erate)
}


* UWAGA:
* Dane z WIOD o value added in trade są w USD!
* A dane z socio-economic accounts w walucie krajowej !

gen country_sec = country*100+wiodn

xtset country_sec year

* K/L growth rate in percentage points*

label variable CAP "Capital input"

* This is still wrong and has tp be changed 
gen KtoL = CAP/LAB
gen KtoL_g = 100 * (KtoL/l.KtoL - 1)

* VA and VA/(1000 employee) at the sectoral level. REAL data, growth rates *

gen VA_r_n = 100* VA / (VA_P)
gen VA_r = 100 * VA * erate / (VA_P )

gen VAemp_r = VA_r / EMP

foreach var in VA_r VAemp_r {
gen `var'_g = 100 * (`var'/l.`var' - 1)
}


* TFP growth rates at the sectoral level. Use REAL data. Do it using labour compensation shares and capital stock index.*

* labor compansation share and capital stock index
* UWAGA:
* Dane z WIOD o value added in trade są w USD!
* A dane z socio-economic accounts w walucie krajowej !

//gen LAB_r_n = 100 * LAB /(VA_P * erate)
/// Czemu tu jest razy 100?
gen CAP_r_n = K_GFCF 
gen CAP_r = K_GFCF * erate

gen LAB_sh = LAB / VA
gen CAP_sh = 1- LAB_sh

bysort country_sec: egen LAB_sh2 = mean(LAB_sh)
gen CAP_sh2 = 1- LAB_sh2

bysort country: egen LAB_sh3 = mean(LAB_sh)
gen CAP_sh3 = 1- LAB_sh3



* value added, labor and capital growth rate *

sort country_sec year



gen LAB_r_g = 100*(log(EMP) - log(l.EMP))

gen CAP_r_g = 100*(log(CAP_r) - log(l.CAP_r))

gen VA_r_n_g_12 = 100*(log(VA_r_n) - log(l12.VA_r_n))

gen LAB_r_n_g_12 = 100*(log(EMP) - log(l12.EMP))

gen CAP_r_n_g_12 = 100*(log(CAP_r_n) - log(l12.CAP_r_n))
gen lnVA = log(VA_r)
gen lnL = (log(EMP))
gen lnK = (log(CAP_r))
gen lnLP = lnVA - lnL
gen dlnVA = (log(VA_r_n) - log(l.VA_r_n))

gen dlnL = (log(EMP) - log(l.EMP))

gen dlnK = (log(CAP_r_n) - log(l.CAP_r_n))

* total factor productivity *

gen TFP1 = (VA_r_g - (LAB_sh * LAB_r_g) - (CAP_sh * CAP_r_g))/100
gen TFP2 = (VA_r_g - (LAB_sh2 * LAB_r_g) - (CAP_sh2 * CAP_r_g))/100
gen TFP3 = (VA_r_g - (LAB_sh3 * LAB_r_g) - (CAP_sh3 * CAP_r_g))/100

gen TFP2_12 = (VA_r_n_g_12 - (LAB_sh2 * LAB_r_n_g_12) - (CAP_sh2 * CAP_r_n_g_12))/100


gen TFP1_l = (log(VA_r) - (LAB_sh * log(EMP)) - (CAP_sh * log(CAP_r)))
gen TFP2_l = (log(VA_r) - (LAB_sh2 * log(EMP)) - (CAP_sh2 * log(CAP_r)))
gen TFP3_l = (log(VA_r) - (LAB_sh3 * log(EMP)) - (CAP_sh3 * log(CAP_r)))

forvalues dupa=1(1)3 {
gen dTFP`dupa' = d.TFP`dupa'
}

saveold dataset, v(11) replace 

exit
///RUN TO HERE

* computing aggregates

use dataset, clear


collapse (sum) GDP_r GDP_r_n GDP_n GDP domvab domvab_n domvab_r domvab_r_n VAEXP VAEXP_r VAEXP_r_n VAEXP_n LAB CAP EMPE H_EMPE, by(countrycode year)
do groups.do
merge 1:1 countrycode year using gdp\agdp_g.dta, nogenerate
merge 1:1 countrycode year using gdp\gdpidx.dta, nogenerate

encode countrycode, gen(country)


* K/L growth rate in percentage points*

label variable CAP "Capital input"

gen KtoL = CAP/LAB

tsset country year
gen KtoL_g = 100 * (KtoL/l.KtoL - 1)

*growth rates

foreach var in GDP_r_n domvab_r_n VAEXP_r_n {
gen `var'_g = 100 * (`var'/l.`var' - 1)
}


* shares
foreach var in domvab_r_n VAEXP_r_n {
gen `var'_sh = `var' / GDP_r_n
}

* shares
foreach var in domvab_n VAEXP_n {
gen `var'_sh = `var' / GDP_n
}


* contributions to GDP growth
foreach var in domvab_r_n VAEXP_r_n {
gen `var'_contrib = l.`var'_sh * `var'_g
}


* compute imputed GDP growth
gen GDP_g_inp = domvab_r_n_contrib + VAEXP_r_n_contrib

*difference between actual GDP growth
gen GDP_g_diff = GDP_g_inp - agdp_g 

*correct contributions
* contributions to GDP growth
foreach var in domvab_r_n VAEXP_r_n {
replace `var'_contrib = `var'_contrib - l.`var'_sh * GDP_g_diff
}


set scheme s2mono
label variable VAEXP_r_n_contrib "Exported value added"
label variable domvab_r_n_contrib "Domestically-absorbed value added"
levelsof(countrycode), local(country)


levelsof(countrycode) if CEEC==1, local(country)
foreach country in `country' {
graph bar (asis) VAEXP_r_n_contrib domvab_r_n_contrib if countrycode=="`country'" & year<2010 & year>1995, over(year) stack title(GDP growth components) subtitle(`country') legend(rows(2)) scheme(s1manual)
graph export "graphs/acontribs/`country'.pdf", replace
}

graph bar (asis) VAEXP_r_n_contrib domvab_r_n_contrib if countrycode=="POL" & year<2010 & year>1995, over(year) stack


/*


* Employment growth decomposition (nb of employees and nb of hours worked)


foreach var in EMPE H_EMPE {
gen `var'_g = 100 * (`var'/l.`var' - 1)
}


foreach var in EMPE H_EMPE {

gen `var'_dom_contrib = l.domvab_r_n_sh * `var'_g
gen `var'_exp_contrib = l.VAEXP_r_n_sh * `var'_g
}


set scheme s2mono
label variable EMPE_exp_contrib "Exported value added contribution"
label variable EMPE_dom_contrib "Domestically-absorbed value added contribution"

levelsof(countrycode), local(country)
foreach country in `country' {
graph bar (asis) EMPE_exp_contrib EMPE_dom_contrib  if countrycode=="`country'" & year<2010 & year>1995, over(year) stack title(Employment growth components) subtitle(`country') legend(rows(2)) scheme(s1manual)
graph export "graphs/acontribs/`country'_emp.pdf", replace
}

*/
* Cumulated
*growth rates
tsset country year
foreach var in GDP_r_n domvab_r_n VAEXP_r_n gdpidx {
gen `var'_g14 = 100 * (`var'/l14.`var' - 1)
}

* contributions to GDP growth
foreach var in domvab_r_n VAEXP_r_n {
gen `var'_contrib_14 = l14.`var'_sh * `var'_g14
}

* compute imputed GDP growth
gen GDP_g_inp_14 = domvab_r_n_contrib_14 + VAEXP_r_n_contrib_14

*difference between actual GDP growth
gen GDP_g_diff_14 = GDP_g_inp_14 - gdpidx_g14 

*correct contributions
* contributions to GDP growth
foreach var in domvab_r_n VAEXP_r_n {
replace `var'_contrib_14 = `var'_contrib_14 - l14.`var'_sh * GDP_g_diff_14
}



* Koniecznie zrobic regresje
* Difference in contrib by countries and by sectors!
label variable VAEXP_r_n_contrib_14 "Exported value added"
label variable domvab_r_n_contrib_14 "Domestically-absorbed value added"

foreach group in CEEC  {
graph bar (asis) VAEXP_r_n_contrib_14 domvab_r_n_contrib_14 if year==2009 & `group'==1, over(countrycode) title(Cumulated GDP growth components) subtitle("1995-2009, `group'") legend(rows(2)) scheme(s1manual) stack
graph export "graphs/acontribs/`group'.pdf", replace
}

foreach group in CEEC EU15 Euro {
graph bar (asis) VAEXP_n_sh domvab_n_sh if year==2011 | year==1995 & `group'==1, over( countrycode year) title(VA components) subtitle("`group'") legend(rows(2)) scheme(s1manual) stack 
}



* Bar chart of changes in shares of exports in GDP
graph bar (asis) VAEXP_n_sh if (year==1995 | year==2009) & CEEC==1, over(year, relabel(1 "95" 2 "09")) over(countrycode) exclude0 stack cw yscale(noextend nofextend) title(Share of exported VA in GDP, size(small)) legend(rows(2)) scheme(s1manual)
capture mkdir graphs/shares
graph export "graphs/shares/CEEC_foreign_va.pdf", replace
keep countrycode year VAEXP_r_n_contrib_14

save gdp_decomp, replace

gen diff =  VAEXP_r_n_contrib - domvab_r_n_contrib 
reg diff if year < 2010, nocons
reg diff if year < 2010 & CEEC==1
reg diff i.country if year < 2010 & CEEC==1, nocons
reg diff i.country if year < 2010 & CEEC==1
reg diff CEEC if year < 2010
reg diff CEEC EU15 if year < 2010
reg diff CEEC EU15 China US if year < 2010
reg diff EU15 China US if year < 2010

** TO BE COMPLETED
* Export decomposition
*** Split into intermediate and final goods.
use dataset, clear
collapse (sum) texpf texpi, by(countrycode year)
do groups.do
gen texp = texpf + texpi 
label variable texpf "Final good exports"
label variable texpi "Intermediate goods exports"
label variable texp "Total exports"

*shares in total exports
foreach var in texpf texpi {
gen `var'_sh = `var' /  texp
}

encode countrycode, gen(countrycoden)
* Cumulated
*growth rates
tsset countrycoden year
foreach var in texpf texpi texp {
gen `var'_g14 = 100 * (`var'/l14.`var' - 1)
}

* contributions to growth
foreach var in  texpf texpi {
gen `var'_contrib_14 = l14.`var'_sh * `var'_g14
}

* compute imputed export  growth
gen texp_g_inp_14 = texpf_contrib_14 + texpi_contrib_14

*difference between actual GDP growth
gen texp_g_diff_14 = texp_g_inp_14 - texp_g14 

*correct contributions
* contributions to GDP growth
foreach var in texpf texpi {
replace `var'_contrib_14 = `var'_contrib_14 - l14.`var'_sh * texp_g_diff_14
}


label variable texpf_contrib "Final good exports"
label variable texpi_contrib "Intermediate goods exports"

foreach group in CEEC   {
graph bar (asis) texpi_contrib_14 texpf_contrib_14 if year==2009 & `group'==1, over(countrycode) title(Cumulated export growth components) subtitle("1995-2009, `group'") legend(rows(2)) scheme(s1manual) stack
graph export "graphs/exports/`group'_exp_growth.pdf", replace
}



* Bar chart of changes in shares of exports in GDP
graph bar (asis) texpi_sh if (year==1995 | year==2009) & CEEC==1, over(year, relabel(1 "95" 2 "09")) over(countrycode) exclude0 stack cw yscale(noextend nofextend) title(Share of intermediates in exports, size(small)) legend(rows(2)) scheme(s1manual)
capture mkdir graphs/shares
graph export "graphs/exports/CEEC_int_exp.pdf", replace



exit

* Export VA growth decomposition
*** Split into intermediate and final goods.
use dataset, clear
foreach var in  texpf	DVAexpf	FVAexpf	texpi	DVAINT1	DVAINT2	INDDVAF	RFLDVAF1	RELDVAF2	REFLDVAI	DDf	DDi	FVAexpi	DFF	DFI	VAEXPb	VAEXP {
*replace `var' = 100* `var' / VA_P
}



gen DVA_final1 = DVAexpf_r_n
gen DVA_final2 = DVAexpf_r_n
gen DVA_intermediate1 = texpi_r_n - FVAexpi_r_n - DFF_r_n - DFI_r_n - DDf_r_n -	DDi_r_n

gen DVA_intermediate2 = DVAINT1_r_n + DVAINT2_r_n + INDDVAF_r_n

*+ RFLDVAF1 + RELDVAF2 + REFLDVAI

gen DVA_total1 = DVA_final1 + DVA_intermediate1
gen DVA_total2 = DVA_final2 + DVA_intermediate2


collapse (sum) texpf	DVA_final1 DVA_final2 DVA_intermediate1 DVA_intermediate2 DVA_total1 DVA_total2 GDP_r_n,  by(countrycode year)
do groups.do
*merge 1:1 countrycode year using gdp\pgdp.dta, nogenerate
merge 1:1 countrycode year using gdp_decomp, nogenerate

*foreach var in DVA_final1 DVA_final2 DVA_intermediate1 DVA_intermediate2 DVA_total1 DVA_total2 {
*replace `var' = `var' / pgdp
*}
* shares
foreach type in 1 2 {
foreach var in DVA_final`type' DVA_intermediate`type'  {
gen `var'_sh = `var' / GDP_r_n
}
}
* growth rates
encode countrycode, gen(countrycoden)
tsset countrycoden year
foreach type in 1 2 {
foreach var in DVA_final`type' DVA_intermediate`type' DVA_total`type'  {
gen `var'_g14 = 100 * (`var'/l14.`var' - 1)
}
}

* contributions to growth
foreach type in 1 2 {
foreach var in DVA_final`type' DVA_intermediate`type' {
gen `var'_contrib_14 = l14.`var'_sh * `var'_g14
}
}

* compute imputed GDP growth
foreach type in 1 2 {
gen GDP_g_inp_`type' = DVA_final`type'_contrib_14 + DVA_intermediate`type'_contrib_14
}

*difference between actual GDP growth
foreach type in 1 2 {
gen GDP_g_diff_`type' = GDP_g_inp_`type' - VAEXP_r_n_contrib_14
}
*correct contributions
* contributions to GDP growth
foreach type in 1 2 {
foreach var in DVA_final`type' DVA_intermediate`type'  {
replace `var'_contrib= `var'_contrib - l.`var'_sh * GDP_g_diff_`type'
}
}



foreach type in 1 2 {
label variable DVA_final`type'_contrib_14 "Final goods GDP contribution"
label variable DVA_intermediate`type'_contrib_14 "Intermediate goods GDP contribution"
}

foreach type in 1 2 {
foreach group in CEEC   {
graph bar (asis) DVA_final`type'_contrib_14 DVA_intermediate`type'_contrib_14 if year==2009 & `group'==1, over(countrycode) title(Contributions to GDP growth) subtitle("1995-2009, `group'") legend(rows(2)) scheme(s1manual) stack
graph export "graphs/exports/`group'_dva_growth_`type'.pdf", replace
}
}





*** Some sectoral decomposition

use dataset, clear
merge m:1 wiod  using meta\desc, nogen
gen countrysector = countrycode + wiod
encode countrysector, gen(countrysectorn)
tsset countrysectorn year

*add country GDP
bysort countrycode year: egen aGDP = total(GDP)
bysort countrycode year: egen aGDP_r = total(GDP_r)
*growth rates
tsset countrysectorn year
foreach var in GDP_r_n domvab_r_n VAEXP_r_n {
gen `var'_g = 100 * (`var'/l.`var' - 1)
}

* shares
foreach var in domvab_r_n VAEXP_r_n {
gen `var'_sh = `var' / GDP_r_n
}

* shares
foreach var in domvab_n VAEXP_n {
gen `var'_sh = `var' / GDP_n
}


* contributions to GDP growth
* This does not really show much
foreach var in domvab_r_n VAEXP_r_n {
gen `var'_contrib = l.`var'_sh * `var'_g
}

tsset countrysectorn year
* Cumulated GDP growth
foreach var in GDP_r_n domvab_r_n VAEXP_r_n {
gen `var'_g14 = 100 * (`var'/l14.`var' - 1)
}

* contributions to GDP growth
foreach var in domvab_r_n VAEXP_r_n {
gen `var'_contrib_14 = l14.`var'_sh * `var'_g14
}

label variable VAEXP_r_n_contrib_14 "Exported value added"
label variable domvab_r_n_contrib_14 "Domestically-absorbed value added"
levelsof wiodn, local(sectors) 
foreach sector in `sectors'  {
graph bar (asis) VAEXP_r_n_contrib_14 domvab_r_n_contrib_14 if year==2009 & wiodn==`sector' & CEEC==1, over(countrycode) title(Cumulated GDP growth components) subtitle("1995-2009, `group'") legend(rows(2)) scheme(s1manual) stack
graph export "graphs/scontribs/`sector'.pdf", replace
}

levelsof wiodn, local(sectors) 
foreach sector in `sectors'  {
graph bar (asis) VAEXP_r_n_contrib_14 domvab_r_n_contrib_14 if year==2009 & wiodn==`sector' & CEEC==1, over(countrycode) title(Cumulated GDP growth components) subtitle("1995-2009, `group'") legend(rows(2)) scheme(s1manual) stack
graph export "graphs/scontribs/`sector'.pdf", replace
}

levelsof name, local(names) 
foreach name in `names' {
twoway (scatter domvab_r_n_contrib_14 VAEXP_r_n_contrib_14, mlabel(abbrev))(scatter domvab_r_n_contrib_14 VAEXP_r_n_contrib_14, msymbol(Oh)) if year==2009 & name=="`name'"
graph export "graphs/scontribs/scatter_`name'.pdf"
}

set scheme s1manual
levelsof name if CEEC==1, local(names) 
foreach name in `names' {
twoway (scatter domvab_r_n_contrib_14 VAEXP_r_n_contrib_14 , mlabel(abbrev) msymbol(none))(scatter domvab_r_n_contrib_14 VAEXP_r_n_contrib_14 [w=GDP], msymbol(Oh)) if year==2009 & name=="`name'" & wiodn <17 & wiodn >2, legend(off)
graph export "graphs/scontribs/scatter_`name'.pdf", replace
}

set scheme s1manual
levelsof name if CEEC==1, local(names) 
foreach name in `names' {
twoway (scatter domvab_r_n_contrib_14 VAEXP_r_n_contrib_14 , mlabel(abbrev) msymbol(none))(scatter domvab_r_n_contrib_14 VAEXP_r_n_contrib_14 [w=GDP], msymbol(Oh)) if year==2009 & name=="`name'" & wiodn <31 & wiodn >18, legend(off)
graph export "graphs/scontribs/scatter_`name'_SVC.pdf", replace
}
